package  
{
	///////////////////////////
	//Ball interface
	///////////////////////////
	import mx.core.UIComponent;
    import mx.controls.Image;
    import flash.events.*;
    import flash.utils.*;
    import flash.display.*;
	import flash.media.Sound;
	import flash.net.URLRequest;
	import mx.utils.HexEncoder;
	
	public class Ball extends UIComponent 
	{
		//Class variables
		public 	var ballSprite : Sprite;
		private var SCREEN_WIDTH : int = 768;
		private var SCREEN_HEIGHT : int = 512;
		private var size : Number;
		private var speed : Number;
		private var x_pos : Number;
		private var y_pos : Number;
		private var dx : Number;
		private var dy : Number;
		private var color : int;
		private var bleep : Sound;
		private var bleepURL : URLRequest;
		
		public function Ball(_xPos : Number, _yPos : Number, _size : Number, _color : int, _speed : Number) 
		{
			trace("Initialising ball entity");
			
			//Initialize all the variables here
			ballSprite = new Sprite();
			
			bleep = new Sound();
			bleepURL = new URLRequest("bleep.MP3");
			bleep.load(bleepURL);
			
			size = _size;
			speed =  _speed;
			color = _color;
			x_pos = _xPos; 
			y_pos = _yPos;
			Init();
		}
		
		public function Init() : void 
		{
			ballSprite.graphics.beginFill(color);
            ballSprite.graphics.drawCircle(0, 0, size);
            ballSprite.graphics.endFill();
			ballSprite.x = x_pos;
			ballSprite.y = y_pos;
			dx = speed * 0.70;
			dy = speed * 0.70;
            Reset();  
		}
		
		public function Reset() : void 
		{
			//fix this, ball needs to be reset every time it touches the bottom of the screen
			ballSprite.x = SCREEN_WIDTH / 2;
			ballSprite.y = SCREEN_HEIGHT / 2;
		}
		
		public function Move() : void 
		{
			ballSprite.x += dx;
			ballSprite.y += dy;
			
			trace("Ball x pos:" + ballSprite.x);
			trace("Ball y pos:" + ballSprite.y);
		}
		
		public function CheckWallCollision() : void
		{
			if (ballSprite.x - size < 0) 
			{
				dx = Math.abs(dx);
			}
            if (ballSprite.x + size > SCREEN_WIDTH) 
			{
				dx = -Math.abs(dx);
			}
            if (ballSprite.y - size < 0)
			{
				dy = Math.abs(dy);
			}
			if (ballSprite.y + size > SCREEN_HEIGHT)
			{
				dy = -Math.abs(dy);
			}
		}
		
		public function CheckPaddleCollision(paddle : Sprite, paddleWidth : Number) : void
		{
			if (ballSprite.hitTestObject(paddle))
            {
				trace("Ball sprite collision with player paddle");
				
				//get new linear velocity in the x-axis
                var t_dx : Number = (ballSprite.x - paddle.x) / (paddleWidth / 2.0) * speed;
				
				//New velocity is blended with the rebound values. 
                dx = (dx + t_dx) / 2; 
                dy = -dy;
				
				bleep.play();
            }
		}
		
		public function CheckBrickCollision(blockSprite : Sprite) : Boolean
		{
			if (ballSprite.hitTestObject(blockSprite))
			{
				trace("Ball sprite collision with brick sprite");
								
				//bounce the ball back (i.e. reverse the direction)
				dx = -dx;
				dy = -dy;
				
				//Move the sprite off the screen. You could delete it dynamically, but
				//it's perhaps cheapr to let the garbabe collector get it when the application terminates. 
				//Perhaps something to investigate...what's more computationally expensive: transforming a sprite or deleting it?
				blockSprite.x = 999;
				blockSprite.y = 999;
				
				bleep.play();
				
				return true;
			} 
			
			return false;
		}
		
		public function BallOutBounds() : Boolean
		{
            if (ballSprite.y - size > SCREEN_HEIGHT - (size * 2.5)) //this is a bit of hack...but i tweaked it just to get it "feeling" right
            {	
				trace("Ball out of bounds");
				
				return true;
            }
			
			return false;
		}
	}

}