package  
{
	///////////////////////////
	//Brick interface
	///////////////////////////
	import mx.core.UIComponent;
    import mx.controls.Image;
    import flash.events.*;
    import flash.utils.*;
    import flash.display.*;
	import mx.utils.HexEncoder;
	
	public class Brick extends UIComponent 
	{
		//Class variables
		private var SCREEN_WIDTH : int = 768;
		private var SCREEN_HEIGHT : int = 512;
		private var BRICK_ROWS : int = 10;
		private var BRICK_COLUMNS : int = 1;
		
		public var brickSprite : Sprite;
		public var blocksArray:Array = new Array(0);
			
		private var brickColor0: Number = 0xec008c;
		private var brickColor1: Number = 0xa864a8;
		private var brickColor2: Number = 0x8393ca;

		private var brickWidth : Number = 40;
		private var brickHeight : Number = 10;
		private var brickXSpacing : Number = 5;
		private var brickYSpacing : Number = 5;
		private var spacingFieldX : Number = BRICK_COLUMNS * brickWidth + (BRICK_COLUMNS-1) * brickXSpacing;
		private var brickFieldX : Number = (brickWidth  - spacingFieldX) / 2;
		private var brickFieldY : Number  = 30;
		
		public function Brick() 
		{
			Init();
			SetBricks();
		}
		
		public function Init() : void 
		{
			brickSprite = new Sprite();
		}
		
		public function SetBricks() : void
		{
			//space the bricks in a nice uniform way
			brickSprite.visible = true;
			
			//Top row
			for (var i : int = 0; i <  BRICK_ROWS; ++i)
			{
				for (var j : int = 0; j < BRICK_COLUMNS; ++j)
				{
					var tempBrick0: Sprite = new Sprite();
					tempBrick0.graphics.beginFill(brickColor0);
					tempBrick0.graphics.drawRect( -brickWidth / 2, -brickHeight / 2, brickWidth, brickHeight);
					tempBrick0.graphics.endFill();
					
					tempBrick0.x = brickFieldX + i * (brickWidth + brickXSpacing) + 150;
					tempBrick0.y = brickFieldY + j * (brickHeight + brickYSpacing) + 10;
					
					brickSprite.addChild(tempBrick0);
					
					blocksArray.push(tempBrick0);
				}
			}
			
			//Mid row
			for (var k : int = 0; k <  BRICK_ROWS; ++k)
			{
				for (var l : int = 0; l < BRICK_COLUMNS; ++l)
				{
					var tempBrick1 : Sprite = new Sprite();
					tempBrick1.graphics.beginFill(brickColor1);
					tempBrick1.graphics.drawRect( -brickWidth / 2, -brickHeight / 2, brickWidth, brickHeight);
					tempBrick1.graphics.endFill();
					
					tempBrick1.x = brickFieldX + k * (brickWidth + brickXSpacing) + 150;
					tempBrick1.y = brickFieldY + l * (brickHeight + brickYSpacing) + 25;
					
					brickSprite.addChild(tempBrick1);
					
					blocksArray.push(tempBrick1);
				}
			}
			
			//Bottom row
			for (var m : int = 0; m <  BRICK_ROWS; ++m)
			{
				for (var n : int = 0; n < BRICK_COLUMNS; ++n)
				{
					var tempBrick2 : Sprite = new Sprite();
					tempBrick2.graphics.beginFill(brickColor2);
					tempBrick2.graphics.drawRect( -brickWidth / 2, -brickHeight / 2, brickWidth, brickHeight);
					tempBrick2.graphics.endFill();
					
					tempBrick2.x = brickFieldX + m * (brickWidth + brickXSpacing) + 150;
					tempBrick2.y = brickFieldY + n * (brickHeight + brickYSpacing) + 40;
					
					brickSprite.addChild(tempBrick2);
					
					blocksArray.push(tempBrick2);
				}
			}
		}
	}
}