////////////////////////////////////////////////////////////////////////////////////////////
// Breakout clone. Written based on a programmer code test requirments specification.
// Written by Vladeta Stojanovic (vladeta_stojanovic@yahoo.co.uk)
//
// Version: 270412_02
////////////////////////////////////////////////////////////////////////////////////////////

package
{
	import mx.core.UIComponent;
    import mx.controls.Image;
    import flash.events.*;
    import flash.utils.*;
    import flash.display.*;
	import flash.text.TextField;

	//////////////////////////////
	//Main application class
	/////////////////////////////
	public class Main extends Sprite 
	{
		//Constnat vars
		private var SCREEN_WIDTH : int = 768;
		private var SCREEN_HEIGHT : int = 512;
		
		//Instance class varaibles
		public var gBall : Ball;
		public var gPaddle : Player;
		public var gBricks : Brick;
		
		//Private class variables
		private var gameTimer : Timer;
		private var gameOver : TextField;
		private var infoText : TextField;
		private var scoreCounter : TextField;
		private var lifeCounter : TextField;
		private static var score : int = 0;
		private static var lives : int = 3;
		
		//Main instnace
		public function Main()
		{
			trace("Initialising new game");
			
			Init();
			
			trace("Starting Game...");
			
			//call the main game loop
			StartGame();
		}
		
		private function Init() : void 
		{
			//init the ball and player paddle
			gBall = new Ball(0, 0, 5, 0xf26522, 5);
			gPaddle = new Player(SCREEN_WIDTH / 2, SCREEN_HEIGHT - 25, 45, 8, 0x2275f2, 0.75);
			addChild(gBall.ballSprite);
			addChild(gPaddle.paddleSprite);
			gBall.Init();
			gPaddle.Init();
			
			//Setup all the text fields
			scoreCounter = new TextField;
			addChild(scoreCounter);
			
			lifeCounter = new TextField;
			addChild(lifeCounter);
					
			//init the bricks
			gBricks = new Brick();
			addChild(gBricks.brickSprite);
		}
		
		//Reset game function
		private function StartGame() : void
		{
			infoText = new TextField();
			infoText.width = 256;
			infoText.height = 256;
			infoText.x = (SCREEN_WIDTH - infoText.width) / 2;
			infoText.y = (SCREEN_HEIGHT - infoText.height) / 2;
			infoText.textColor = 0x00ff00;

			infoText.text = "Click anywhere to start a new game.\n Use the mouse to move the paddle.";
			addChild(infoText);
			
			stage.addEventListener(MouseEvent.CLICK, GetTicks); 
		}
		
		//Game timer - used to uprate the game
		private function GetTicks(eventObject:MouseEvent) : void 
		{
			//clear info text
			removeChild(infoText);
			gameTimer = new Timer(10); 
			gameTimer.addEventListener(TimerEvent.TIMER, Update);
			gameTimer.start();
		}
		
		public function DisplayInfo() : void 
		{
			scoreCounter.x = 0;
			scoreCounter.y = 10;
			scoreCounter.textColor = 0x00746b;
			scoreCounter.text = "Score: " + score;
			
			lifeCounter.x = 650;
			lifeCounter.y = 10;
			lifeCounter.textColor = 0x00746b;
			lifeCounter.text = "Lives: " + lives;
		}
		
		public function GameOver() : void 
		{
			gameTimer.stop();
			gameOver = new TextField();
			gameOver.x = (SCREEN_WIDTH - gameOver.width) / 2;
			gameOver.y = (SCREEN_HEIGHT - gameOver.height) / 2;
			gameOver.textColor = 0x00ff00;

			gameOver.text = "GAME OVER!";

			addChild(gameOver);
		}
		
		//Main game loop
		public function Update(evt:TimerEvent) : void 
		{
			if (lives == 0 || score == 30)
			{
				//If game over, get user to click and reset everything
				GameOver();
			}
			
			if (gBall.BallOutBounds())
			{
				//subtract player life
				if (lives > 0)
				{
					--lives;
				}
				gBall.Reset();
			}
			
			gBall.Move();	
			gPaddle.Move(this.mouseX);
			gBall.CheckWallCollision();
			gBall.CheckPaddleCollision(gPaddle.paddleSprite, gPaddle.paddleWidth);
			
			for (var i : int = 0; i < gBricks.blocksArray.length; ++i)
			{
				if (gBall.CheckBrickCollision(gBricks.blocksArray[i]))
				{
					if (score <= 30)
					{
						++score;
					}
				}
			}
			
			DisplayInfo();
			
			
		}
	}
}
