package  
{
	////////////////////////////
	//Player/Paddle interface
	///////////////////////////
	import mx.core.UIComponent;
    import mx.controls.Image;
    import flash.events.*;
    import flash.utils.*;
    import flash.display.*;
	import mx.utils.HexEncoder;
	
	public class Player
	{
		//Class variables
		public 	var paddleSprite : Sprite;
		public var paddleWidth : Number;
		public var paddleHeight: Number;
		private var SCREEN_WIDTH : int = 768;
		private var SCREEN_HEIGHT : int = 512;
		private var speed : Number;
		private var color : int;
		
		public function Player(_xPos : Number, _yPos : Number, _width : Number, _height : Number, _color : Number, _speed : Number) 
		{
			trace("Initialising player entity");
			
			//Initialize the player paddle variables here
			paddleSprite = new Sprite();
			paddleSprite.x = _xPos;
			paddleSprite.y = _yPos;
			paddleWidth = _width;
			paddleHeight = _height;
			color = _color;
			speed = _speed;
		}	
		
		public function Init() : void
		{
			paddleSprite.graphics.beginFill(color);
			paddleSprite.graphics.drawRect( -paddleWidth / 2, -paddleHeight / 2, paddleWidth, paddleHeight);
			paddleSprite.graphics.endFill();
		}
		
		public function Move(_mouseX : Number) : void 
		{
			paddleSprite.x = _mouseX * speed;
			
			//make usre the paddle doesnt go off-screen
			if (paddleSprite.x - paddleWidth < 0)
			{
				paddleSprite.x = paddleWidth;
			}
            if (paddleSprite.x + paddleWidth > SCREEN_WIDTH) 
			{
				paddleSprite.x = SCREEN_WIDTH - paddleWidth;
			}
			
			trace("Player x pos:" + paddleSprite.x);
			trace("Player y pos:" + paddleSprite.y);
		}
	}
}